## pimd 2.1.0

=== Makefile ===
#
# Makefile for the Daemon part of PIM-SMv2.0,
# Protocol Independent Multicast, Sparse-Mode version 2.0
#
#
#  Questions concerning this software should be directed to 
#  Pavlin Ivanov Radoslavov (pavlin@catarina.usc.edu)
#
#  $Id: Makefile,v 1.64 2001/11/13 20:51:46 pavlin Exp $
#
# XXX: SEARCH FOR "CONFIGCONFIGCONFIG" (without the quotas) for the lines
# that might need configuration

PROG_NAME=pimd

#CONFIGCONFIGCONFIG
# Misc. definitions
# -DBROKEN_CISCO_CHECKSUM :
#   If your RP is buggy cisco PIM-SMv2 implementation that computes
#   the PIM-Register checksum over the whole pkt instead only over
#   the header, you need to define this. Otherwise, all your PIM-Register
#   may be dropped by the cisco-RP.
# -DPIM_OLD_KERNEL : older PIM kernels don't prepare the inner encapsulated
#   pkt, and the daemon had to take care of the details
#   (prior to pimd-2.1.0-alpha29). Newer kernels will prepare everything,
#   and then the daemon should not touch anything. Unfortunately, both
#   kernels are not compatible. If you still have one of those old kernels
#   around and want to use it, then define PIM_OLD_KERNEL here.
# -DPIM_REG_KERNEL_ENCAP : Register kernel encapsulation. Your kernel must
#   support registers kernel encapsulation to be able to use it.
# -DKERNEL_MFC_WC_G : (*,G) kernel MFC support. Use it ONLY with (*,G)
#   capable kernel
# -DSAVE_MEMORY : saves 4 bytes per unconfigured interface
#   per routing entry. If set, configuring such interface will restart the
#   daemon and will flush the routing table.
#
#  marian stagarescu: marian@cidera.com
#
# -DSCOPED_ACL :
#   use "scoped [mcast_addr] masklen [l]" statements in pimd.conf: e.g.
#
#   phyint fxp0 scoped "addr" masklen "len" 
#
#   if you want to install NUL OIF for the "scoped groups"
#

MISCDEFS=	# -DPIM_REG_KERNEL_ENCAP #-DKERNEL_MFC_WC_G

#
# Version control stuff. Nothing should be changed
#
VERSION = `cat VERSION`
CVS_VERSION = `cat VERSION | sed 'y/./_/' | sed 'y/-/_/'`
CVS_LAST_VERSION=`cat CVS_LAST_VERSION`
PROG_VERSION =  ${PROG_NAME}-${VERSION}
PROG_CVS_VERSION = ${PROG_NAME}_${CVS_VERSION}
PROG_CVS_LAST_VERSION = ${PROG_NAME}_${CVS_LAST_VERSION}

# TODO: XXX: CURRENTLY SNMP NOT SUPPORTED!!!!
#
# Uncomment the following eight lines if you want to use David Thaler's
# CMU SNMP daemon support.
#
#SNMPDEF=	-DSNMP
#SNMPLIBDIR=	-Lsnmpd -Lsnmplib
#SNMPLIBS=	-lsnmpd -lsnmp
#CMULIBS=	snmpd/libsnmpd.a snmplib/libsnmp.a
#MSTAT=		mstat
#SNMP_SRCS=	snmp.c
#SNMP_OBJS=	snmp.o
#SNMPCLEAN=	snmpclean
# End SNMP support

#CONFIGCONFIGCONFIG
# Uncomment the following line if you want to use RSRR (Routing
# Support for Resource Reservations), currently used by RSVP.
#RSRRDEF=	-DRSRR

CC=		gcc
MCAST_INCLUDE=	-Iinclude
LDFLAGS=
#CONFIGCONFIGCONFIG
PURIFY=		purify -cache-dir=/tmp -collector=/import/pkgs/gcc/lib/gcc-lib/sparc-sun-sunos4.1.3_U1/2.7.2.2/ld

COMMON_CFLAGS= ${MCAST_INCLUDE} ${SNMPDEF} ${RSRRDEF} ${MISCDEFS} -DPIM

#CONFIGCONFIGCONFIG
### Compilation flags for different platforms. Uncomment only one of them

## FreeBSD	-D__FreeBSD__ is defined by the OS
## FreeBSD-3.x, FreeBSD-4.x
CFLAGS= -Wall	-g	-Iinclude/freebsd ${COMMON_CFLAGS}
## FreeBSD-2.x
#CFLAGS= -Wall	-g	-Iinclude/freebsd2 ${COMMON_CFLAGS}

## NetBSD	-DNetBSD is defined by the OS
#CFLAGS= -Wall	-g	-Iinclude/netbsd ${COMMON_CFLAGS}

## OpenBSD	-DOpenBSD is defined by the OS
#CFLAGS= -Wall	-g	-Iinclude/openbsd ${COMMON_CFLAGS}

## BSDI		-D__bsdi__ is defined by the OS
#CFLAGS=	-g  ${COMMON_CFLAGS}

## SunOS, OSF1, gcc
#CFLAGS= -Wall	-g -Iinclude/sunos-gcc -DSunOS=43 ${COMMON_CFLAGS}
## SunOS, OSF1, cc
#CFLAGS=	-g -Iinclude/sunos-cc  -DSunOS=43 ${COMMON_CFLAGS}

## IRIX
#CFLAGS= -Wall	-g -D_BSD_SIGNALS -DIRIX ${COMMON_CFLAGS}

## Solaris 2.5, gcc
#CFLAGS= -Wall	-g -DSYSV -DSunOS=55 ${COMMON_CFLAGS}
## Solaris 2.5, cc
#CFLAGS= 	-g -DSYSV -DSunOS=55 ${COMMON_CFLAGS}
## Solaris 2.6
#CFLAGS=	-g -DSYSV -DSunOS=56 ${COMMON_CFLAGS}
## Solaris 2.x
#LIB2=		-L/usr/ucblib -lucb -L/usr/lib -lsocket -lnsl

## Linux (there is a good chance the include files won't work ;)
LINUX_INCLUDE	=	-Iinclude/linux
LINUX_DEFS	=	-D__BSD_SOURCE \
			-DRAW_INPUT_IS_RAW \
			-DRAW_OUTPUT_IS_RAW \
			-DIOCTL_OK_ON_RAW_SOCKET \
			-DLinux

## Old Linux (linux-2.1.103 for example)
#CFLAGS= -Wall -g -Dold_Linux ${LINUX_INCLUDE} ${LINUX_DEFS} ${COMMON_CFLAGS}

## Newer Linux (linux-2.1.127 for example)
#CFLAGS= -Wall -g ${LINUX_INCLUDE} ${LINUX_DEFS} ${COMMON_CFLAGS}


LIBS=		${SNMPLIBDIR} ${SNMPLIBS} ${LIB2}
LINTFLAGS=	${MCAST_INCLUDE} ${CFLAGS}

IGMP_SRCS=	igmp.c igmp_proto.c trace.c
IGMP_OBJS=	igmp.o igmp_proto.o trace.o
ROUTER_SRCS=	inet.c kern.c main.c config.c debug.c netlink.c routesock.c \
		vers.c callout.c	
ROUTER_OBJS=	inet.o kern.o main.o config.o debug.o netlink.o routesock.o \
		vers.o callout.o
PIM_SRCS=	route.c vif.c timer.c mrt.c pim.c pim_proto.c rp.c
PIM_OBJS=	route.o vif.o timer.o mrt.o pim.o pim_proto.o rp.o
DVMRP_SRCS=	dvmrp_proto.c
DVMRP_OBJS=	dvmrp_proto.o
RSRR_SRCS=	rsrr.c
RSRR_OBJS=	rsrr.o
RSRR_HDRS=      rsrr.h rsrr_var.h
HDRS=		debug.h defs.h dvmrp.h igmpv2.h mrt.h pathnames.h pimd.h \
		trace.h vif.h ${RSRR_HDRS}
SRCS=		${IGMP_SRCS} ${ROUTER_SRCS} ${PIM_SRCS} ${DVMRP_SRCS} \
		${SNMP_SRCS} ${RSRR_SRCS}
OBJS=		${IGMP_OBJS} ${ROUTER_OBJS} ${PIM_OBJS} ${DVMRP_OBJS} \
		${SNMP_OBJS} ${RSRR_OBJS}
DISTFILES=	README README.config README.config.jp README.debug \
		CHANGES ${SRCS} ${HDRS} VERSION LICENSE \
		LICENSE.mrouted Makefile pimd.conf BUGS.TODO include

all: ${PROG_NAME}

${PROG_NAME}: ${OBJS} ${CMULIBS}
	rm -f $@
	${CC} ${LDFLAGS} -o $@ ${CFLAGS} ${OBJS} ${LIBS}

purify: ${OBJS}
	${PURIFY} ${CC} ${LDFLAGS} -o ${PROG_NAME} ${CFLAGS} ${OBJS} ${LIBS}

vers.c:	VERSION
	rm -f $@
	sed -e 's/.*/char todaysversion[]="&";/' < VERSION > vers.c

release: cvs-commit cvs-tag last-dist

re-release: cvs-commit cvs-retag last-dist

cvs-commit:
	cvs commit -m "make cvs-commit   VERSION=${PROG_VERSION}"

cvs-tag:
	cvs tag ${PROG_CVS_VERSION}
	`cat VERSION | sed 'y/./_/' | sed 'y/-/_/' > CVS_LAST_VERSION`

cvs-retag:
	cvs tag -F ${PROG_CVS_VERSION}
	`cat VERSION | sed 'y/./_/' | sed 'y/-/_/' > CVS_LAST_VERSION`

last-dist:
	- mv ${PROG_VERSION} _${PROG_VERSION}.SAVE_
	- rm -rf ${PROG_VERSION}
	- rm -rf ${PROG_VERSION}.tar.gz
	cvs export -r ${PROG_CVS_LAST_VERSION} -d releases/${PROG_VERSION} ${PROG_NAME}
	mv releases/${PROG_VERSION} .
	tar cvf - ${PROG_VERSION} | gzip > ${PROG_VERSION}.tar.gz
	rm -rf ${PROG_VERSION}
	- mv _${PROG_VERSION}.SAVE_ ${PROG_VERSION}

curr-dist:
	cvs commit -m "make curr-dist   VERSION=${PROG_VERSION}"
	- mv ${PROG_NAME}-current _${PROG_NAME}-current.SAVE_
	- rm -rf ${PROG_NAME}-current
	- rm -rf ${PROG_NAME}-current.tar.gz
	cvs checkout -d releases/${PROG_NAME}-current ${PROG_NAME}
	mv releases/${PROG_NAME}-current .
	tar cvf - ${PROG_NAME}-current | gzip > ${PROG_NAME}-current.tar.gz
	rm -rf ${PROG_NAME}-current
	- mv _${PROG_NAME}.SAVE_ ${PROG_NAME}

curr-diff:
	cvs commit -m "make curr-diff   VERSION=${PROG_VERSION}"
	cvs rdiff -kk -u -r ${PROG_CVS_LAST_VERSION} ${PROG_NAME} > ${PROG_NAME}-current.diff

install:	${PROG_NAME}
	install -d /usr/local/bin
	install -m 0755 -f /usr/local/bin ${PROG_NAME}
	- mv /etc/pimd.conf /etc/pimd.conf.old
	cp pimd.conf /etc
	echo "Don't forget to check/edit /etc/pimd.conf!!!"

clean:	FRC ${SNMPCLEAN}
	rm -f ${OBJS} core ${PROG_NAME} tags TAGS *.o

depend:	FRC
	mkdep ${CFLAGS} ${SRCS}

lint:	FRC
	lint ${LINTFLAGS} ${SRCS}

tags:	${SRCS}
	ctags ${SRCS}

cflow:	FRC
	cflow ${MCAST_INCLUDE} ${SRCS} > cflow.out

cflow2:	FRC
	cflow -ix ${MCAST_INCLUDE} ${SRCS} > cflow2.out

rcflow:	FRC
	cflow -r ${MCAST_INCLUDE} ${SRCS} > rcflow.out

rcflow2: FRC
	cflow -r -ix ${MCAST_INCLUDE} ${SRCS} > rcflow2.out

TAGS:	FRC
	etags ${SRCS}

snmpd/libsnmpd.a:
	cd snmpd; make)

snmplib/libsnmp.a:
	(cd snmplib; make)

snmpclean:	FRC
	-(cd snmpd; make clean)
	-(cd snmplib; make clean)

old-dist:	
	- mv $$PROG_NAME} ${PROG_NAME}.bin
	- rm -rf pimd-${VERSION}
	- rm pimd-${VERSION}.tar.gz
	- rm pimd-${VERSION}.tar.gz.formail
	cvs checkout -r pimd_${CVS_VERSION} pimd
	mv pimd pimd-${VERSION}
	tar cvf - pimd-${VERSION} | gzip > pimd-${VERSION}.tar.gz
	uuencode pimd-${VERSION}.tar.gz pimd-${VERSION}.tar.gz > pimd-${VERSION}.tar.gz.formail
	rm -rf pimd-${VERSION}
	- mv pimd.bin pimd

old-diff:
	- rm -rf diff.old
	- mkdir diff.old
	- mv diff-* diff.old
	mkdir diff-${VERSION}-${OLD_VERSION}
	- for i in ${DISTFILES}; do \
		if ! cmp -s ${PIMD_BASE}/$$i $$i ; then \
			diff -u ${PIMD_BASE}/$$i $$i > diff-${VERSION}-${OLD_VERSION}/$$i.diff; \
		fi \
	done
	- rm diff*.tar.gz
	- tar cvf diff-${VERSION}-${OLD_VERSION}.tar diff-${VERSION}-${OLD_VERSION}
	- gzip diff-${VERSION}-${OLD_VERSION}.tar
	- uuencode diff-${VERSION}-${OLD_VERSION}.tar.gz diff-${VERSION}-${OLD_VERSION}.tar.gz > diff.formail

FRC:



# DO NOT DELETE THIS LINE -- mkdep uses it.

## pimd 2.1.1

=== Makefile ===
# -*-Makefile-*-
#
# Protocol Independent Multicast, Sparse-Mode version 2.0
#
# 2010-01-16  Joachim Nilsson <jocke@vmlinux.org>
#       * Cleanup and refactoring for cross building.
#
# 2003-03-27  Antonin Kral <A.Kral@sh.cvut.cz>
# 	* Modified for Debian
#
# 2001-11-13  Pavlin Ivanov Radoslavov (pavlin@catarina.usc.edu)
#       * Original Makefile
#

# VERSION       ?= $(shell git tag -l | tail -1)
VERSION       ?= 2.1.1
EXEC           = pimd
PKG            = $(EXEC)-$(VERSION)
ARCHIVE        = $(PKG).tar.bz2

ROOTDIR       ?= $(dir $(shell pwd))
CC             = $(CROSS)gcc

prefix        ?= /usr/local
sysconfdir    ?= /etc
datadir        = $(prefix)/share/doc/pimd

IGMP_OBJS      = igmp.o igmp_proto.o trace.o
ROUTER_OBJS    = inet.o kern.o main.o config.o debug.o netlink.o routesock.o \
		 vers.o callout.o
PIM_OBJS       = route.o vif.o timer.o mrt.o pim.o pim_proto.o rp.o
DVMRP_OBJS     = dvmrp_proto.o
RSRR_OBJS      = rsrr.o
RSRR_HDRS      = rsrr.h rsrr_var.h
HDRS           = debug.h defs.h dvmrp.h igmpv2.h mrt.h pathnames.h pimd.h \
		 trace.h vif.h $(RSRR_HDRS)
OBJS           = $(IGMP_OBJS) $(ROUTER_OBJS) $(PIM_OBJS) $(DVMRP_OBJS) \
		 $(SNMP_OBJS) $(RSRR_OBJS)
SRCS           = $(OBJS:.o=.c)
DEPS           = $(addprefix .,$(SRCS:.c=.d))
DISTFILES      = README README.config README.config.jp README.debug \
		 CHANGES INSTALL LICENSE LICENSE.mrouted \
		 TODO CREDITS FAQ AUTHORS

include rules.mk
include config.mk
include snmp.mk

MCAST_INCLUDE  = -Iinclude
PURIFY         = purify -cache-dir=/tmp -collector=/import/pkgs/gcc/lib/gcc-lib/sparc-sun-sunos4.1.3_U1/2.7.2.2/ld
COMMON_CFLAGS  = $(MCAST_INCLUDE) $(SNMPDEF) $(RSRRDEF) $(MISCDEFS) -DPIM
CFLAGS         = $(INCLUDES) $(DEFS) $(COMMON_CFLAGS) $(USERCOMPILE)

LDLIBS         = $(SNMPLIBDIR) $(SNMPLIBS) $(LIB2)

LINT           = splint
LINTFLAGS      = $(MCAST_INCLUDE) $(filter-out -W -Wall -g, $(CFLAGS)) -posix-lib -weak -skipposixheaders

all: $(EXEC)

$(EXEC): $(OBJS) $(CMULIBS)
ifdef Q
	@printf "  LINK    $(subst $(ROOTDIR),,$(shell pwd))/$@\n"
endif
	$(Q)$(CC) $(CFLAGS) $(LDFLAGS) -Wl,-Map,$@.map -o $@ $^ $(LDLIBS$(LDLIBS-$(@)))

purify: $(OBJS)
	@$(PURIFY) $(CC) $(LDFLAGS) -o $(EXEC) $(CFLAGS) $(OBJS) $(LDLIBS)

vers.c:
	@echo $(VERSION) | sed -e 's/.*/char todaysversion[]="&";/' > vers.c

install: $(EXEC)
	$(Q)[ -n "$(DESTDIR)" -a ! -d $(DESTDIR) ] || install -d $(DESTDIR)
	$(Q)install -d $(DESTDIR)$(prefix)/sbin
	$(Q)install -d $(DESTDIR)$(sysconfdir)
	$(Q)install -d $(DESTDIR)$(datadir)
	$(Q)install -m 0755 $(EXEC) $(DESTDIR)$(prefix)/sbin/$(EXEC)
	$(Q)install --backup=existing -m 0644 $(EXEC).conf $(DESTDIR)$(sysconfdir)/$(EXEC).conf
	$(Q)for file in $(DISTFILES); do \
		install -m 0644 $$file $(DESTDIR)$(datadir)/$$file; \
	done

uninstall:
	-$(Q)$(RM) $(DESTDIR)$(prefix)/sbin/$(EXEC)
	-$(Q)$(RM) $(DESTDIR)$(sysconfdir)/$(EXEC).conf
	-$(Q)$(RM) -r $(DESTDIR)$(datadir)

clean: $(SNMPCLEAN)
	-$(Q)$(RM) $(OBJS) $(EXEC)

distclean:
	-$(Q)$(RM) $(OBJS) core $(EXEC) vers.c tags TAGS *.o *.map .*.d *.out

dist:
	@echo "Building bzip2 tarball of $(PKG) in parent dir..."
	git archive --format=tar --prefix=$(PKG)/ $(VERSION) | bzip2 >../$(ARCHIVE)
	@(cd ..; md5sum $(ARCHIVE))

lint:
	@$(LINT) $(LINTFLAGS) $(SRCS)

tags: $(SRCS)
	@ctags $(SRCS)

cflow:
	@cflow $(MCAST_INCLUDE) $(SRCS) > cflow.out

cflow2:
	@cflow -ix $(MCAST_INCLUDE) $(SRCS) > cflow2.out

rcflow:
	@cflow -r $(MCAST_INCLUDE) $(SRCS) > rcflow.out

rcflow2:
	@cflow -r -ix $(MCAST_INCLUDE) $(SRCS) > rcflow2.out

TAGS:
	@etags $(SRCS)

snmpd/libsnmpd.a:
	@make -C snmpd

snmplib/libsnmp.a:
	@make -C snmplib

snmpclean:
	@for dir in snmpd snmplib; do \
		make -C $$dir clean;  \
	done

build-deb:
	git-buildpackage --git-ignore-new --git-upstream-branch=master

ifneq ($(MAKECMDGOALS),clean)
-include $(DEPS)
endif

## pimd 2.1.2-2

=== Makefile ===
# -*-Makefile-*-
#
# Protocol Independent Multicast, Sparse-Mode version 2.0
#
# 2010-08-21  Joachim Nilsson <jocke@vmlinux.org>
#       * Cleanup unportable rules.mk and simplify for build
#         using BSD make, and similar.
#
# 2010-01-16  Joachim Nilsson <jocke@vmlinux.org>
#       * Cleanup and refactoring for cross building.
#
# 2003-03-27  Antonin Kral <A.Kral@sh.cvut.cz>
# 	* Modified for Debian
#
# 2001-11-13  Pavlin Ivanov Radoslavov (pavlin@catarina.usc.edu)
#       * Original Makefile
#

# VERSION      ?= $(shell git tag -l | tail -1)
VERSION      ?= 2.1.2
EXEC          = pimd
CONFIG        = $(EXEC).conf
PKG           = $(EXEC)-$(VERSION)
ARCHIVE       = $(PKG).tar.bz2

ROOTDIR      ?= $(dir $(shell pwd))
RM           ?= rm -f
CC           ?= $(CROSS)gcc

prefix       ?= /usr/local
sysconfdir   ?= /etc
datadir       = $(prefix)/share/doc/pimd
mandir        = $(prefix)/share/man/man8


# Uncomment the following line if you want to use RSRR (Routing
# Support for Resource Reservations), currently used by RSVP.
#RSRRDEF       = -DRSRR
RSRR_OBJS     = rsrr.o

IGMP_OBJS     = igmp.o igmp_proto.o trace.o
ROUTER_OBJS   = inet.o kern.o main.o config.o debug.o netlink.o routesock.o \
		vers.o callout.o ${RSRR_OBJS}
PIM_OBJS      = route.o vif.o timer.o mrt.o pim.o pim_proto.o rp.o
DVMRP_OBJS    = dvmrp_proto.o

# This magic trick looks like a comment, but works on BSD PMake
#include <config.mk>
include config.mk
#include <snmp.mk>
include snmp.mk

## Common
CFLAGS        = $(MCAST_INCLUDE) $(SNMPDEF) $(RSRRDEF) $(INCLUDES) $(DEFS) $(USERCOMPILE)
CFLAGS       += -O2 -W -Wall -Werror
#CFLAGS       += -O -g
LDLIBS        = $(SNMPLIBDIR) $(SNMPLIBS) $(EXTRA_LIBS)
OBJS          = $(IGMP_OBJS) $(ROUTER_OBJS) $(PIM_OBJS) $(DVMRP_OBJS) \
		$(SNMP_OBJS) $(RSRR_OBJS) $(EXTRA_OBJS)
SRCS          = $(OBJS:.o=.c)
DEPS          = $(addprefix .,$(SRCS:.c=.d))
MANS          = $(addsuffix .8,$(EXEC))
DISTFILES     = README README.config README.config.jp README.debug \
		CHANGES INSTALL LICENSE LICENSE.mrouted \
		TODO CREDITS FAQ AUTHORS

LINT          = splint
LINTFLAGS     = $(MCAST_INCLUDE) $(filter-out -W -Wall -Werror, $(CFLAGS)) -posix-lib -weak -skipposixheaders

PURIFY        = purify
PURIFYFLAGS   = -cache-dir=/tmp -collector=/import/pkgs/gcc/lib/gcc-lib/sparc-sun-sunos4.1.3_U1/2.7.2.2/ld

all: $(EXEC)

.c.o:
	@printf "  CC      $@\n"
	@$(CC) $(CFLAGS) $(CPPFLAGS) -c -o $@ $<

$(EXEC): $(OBJS)
	@printf "  LINK    $@\n"
	@$(CC) $(CFLAGS) $(LDFLAGS) -Wl,-Map,$@.map -o $@ $(OBJS) $(LDLIBS)

purify: $(OBJS)
	@$(PURIFY) $(PURIFYFLAGS) $(CC) $(LDFLAGS) -o $(EXEC) $(CFLAGS) $(OBJS) $(LDLIBS)

vers.c:
	@echo $(VERSION) | sed -e 's/.*/char todaysversion[]="&";/' > vers.c

install: $(EXEC)
	@install -d $(DESTDIR)$(prefix)/sbin
	@install -d $(DESTDIR)$(sysconfdir)
	@install -d $(DESTDIR)$(datadir)
	@install -d $(DESTDIR)$(mandir)
	@install -m 0755 $(EXEC) $(DESTDIR)$(prefix)/sbin/$(EXEC)
	@install -b -m 0644 $(CONFIG) $(DESTDIR)$(sysconfdir)/$(CONFIG)
	@for file in $(DISTFILES); do \
		install -m 0644 $$file $(DESTDIR)$(datadir)/$$file; \
	done
	@for file in $(MANS); do \
		install -m 0644 $$file $(DESTDIR)$(mandir)/$$file; \
	done

uninstall:
	-@$(RM) $(DESTDIR)$(prefix)/sbin/$(EXEC)
	-@$(RM) $(DESTDIR)$(sysconfdir)/$(CONFIG)
	-@$(RM) -r $(DESTDIR)$(datadir)
	-@for file in $(MANS); do \
		$(RM) $(DESTDIR)$(mandir)/$$file; \
	done

clean: $(SNMPCLEAN)
	-@$(RM) $(OBJS) $(EXEC)

distclean:
	-@$(RM) $(OBJS) core $(EXEC) vers.c tags TAGS *.o *.map .*.d *.out tags TAGS

dist:
	@echo "Building bzip2 tarball of $(PKG) in parent dir..."
	git archive --format=tar --prefix=$(PKG)/ $(VERSION) | bzip2 >../$(ARCHIVE)
	@(cd ..; md5sum $(ARCHIVE))

build-deb:
	@echo "Building .deb if $(PKG)..."
	git-buildpackage --git-ignore-new --git-upstream-branch=master

lint:
	@$(LINT) $(LINTFLAGS) $(SRCS)

tags: $(SRCS)
	@ctags $(SRCS)

cflow:
	@cflow $(MCAST_INCLUDE) $(SRCS) > cflow.out

cflow2:
	@cflow -ix $(MCAST_INCLUDE) $(SRCS) > cflow2.out

rcflow:
	@cflow -r $(MCAST_INCLUDE) $(SRCS) > rcflow.out

rcflow2:
	@cflow -r -ix $(MCAST_INCLUDE) $(SRCS) > rcflow2.out

TAGS:
	@etags $(SRCS)

snmpd/libsnmpd.a:
	@make -C snmpd

snmplib/libsnmp.a:
	@make -C snmplib

snmpclean:
	@for dir in snmpd snmplib; do \
		make -C $$dir clean;  \
	done

=== debian/changelog ===
pimd (2.1.2-2) unstable; urgency=low

  * Patch from Joachim to fix FTBFS issue (Closes: #595584)

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Sun, 05 Sep 2010 21:06:41 +0200

pimd (2.1.2-1) unstable; urgency=low

  * New upstream release
  * updated to the latest Debian policies
  * lintian cleanup

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Sun, 05 Sep 2010 07:56:40 +0200

pimd (2.1.1-2) unstable; urgency=low

  * Update rules file with new section for pimd man page.  Moved to
    section 8 from 1.

 -- Joachim Nilsson <joachim.nilsson@member.fsf.org>  Thu, 27 May 2010 00:19:31 +0100

pimd (2.1.1-1) unstable; urgency=low

  * New upstream maintainer - Joachim Nilsson
  * Package built to follow upstream, Closes: #565716
  * updated to the latest Debian policies
  * added lintian override for empty-debian-diff as debian dir is maintained
    along the upstream sources

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Mon, 18 Jan 2010 18:38:39 +0100

pimd (2.1.0-alpha29.17-9) unstable; urgency=low

  * fixed rp_address handling on big endian machines, many thanks to Alexander
    Clouter for providing patch (Closes: #503116)
  * fixed Lintian warning debian-rules-ignores-make-clean-error
  * fixed Lintian warning package-uses-deprecated-debhelper-compat-version

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Sun, 08 Feb 2009 15:26:23 +0100

pimd (2.1.0-alpha29.17-8.1) unstable; urgency=low

  * Non-maintainer upload.
  * Added LSB formatted dependency info in init.d script (closes: #469226)

 -- Peter Eisentraut <petere@debian.org>  Thu, 03 Apr 2008 14:15:02 +0200

pimd (2.1.0-alpha29.17-8) unstable; urgency=low

  * explicit removal of
    removed include/linux/netinet/in.h
    removed include/linux/netinet/in-slackware.h

    thanks Julien, Closes: #423516, #422591

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Mon, 06 Aug 2007 02:04:31 +0000

pimd (2.1.0-alpha29.17-7) unstable; urgency=high

  * included patch from Prasanna Krishnamoorthy, Closes #422591
    removed include/linux/netinet/in.h
    removed include/linux/netinet/in-slackware.h

    goal is to fix missing reference to ntohl()

  * init script works with newer kernels, Closes #231677

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Mon, 07 May 2007 19:14:32 +0000

pimd (2.1.0-alpha29.17-6) unstable; urgency=low

  * #287318 is not a bug since previsou release, closes #287318
  * rules correction, closes #268475
  * int pid removed from defs.h, closes #287915

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Fri, 28 Jan 2005 11:11:18 +0100

pimd (2.1.0-alpha29.17-5) unstable; urgency=low

  * /etc/pimd.conf added to conffiles, closes #287318

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Thu,  6 Jan 2005 23:18:36 +0100

pimd (2.1.0-alpha29.17-4) unstable; urgency=low

  * Addapted patch for staticRP support by Peter Mann, please refer to
    README.Debian

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Tue, 10 Aug 2004 10:53:15 +0200

pimd (2.1.0-alpha29.17-3) unstable; urgency=low

  * Changed description, kernel patch is not longer needed

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Sat, 31 May 2003 08:48:11 +0200

pimd (2.1.0-alpha29.17-2) unstable; urgency=low

  * Changed path of pid file

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Mon,  7 Apr 2003 19:50:09 +0200

pimd (2.1.0-alpha29.17-1) unstable; urgency=low

  * Initial Release, closes #186454

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Thu, 27 Mar 2003 10:12:47 +0100

=== debian/control ===
Source: pimd
Section: net
Priority: optional
Maintainer: Antonin Kral <A.Kral@sh.cvut.cz>
Build-Depends: debhelper (>= 7)
Standards-Version: 3.9.1

Package: pimd
Architecture: any
Homepage: http://github.com/troglobit/pimd
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: mrouted
Description: multicast routing daemon (PIMv2)
 pimd is implementation of Protocol Independent Multicast routing daemon.
 It supports PIMv2-SM on FreeBSD, NetBSD, OpenBSD, Linux. Enabled PIM support
 in kernel is needed.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.
	touch configure-stamp

build: build-stamp

build-stamp: configure-stamp 
	dh_testdir
	# Add here commands to compile the package.
	$(MAKE)
	#/usr/bin/docbook-to-man debian/pimd.sgml > pimd.8
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	# Add here commands to clean up after the build process.
	[ ! -f Makefile ] || $(MAKE) clean
	[ ! -f Makefile ] || $(MAKE) distclean
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	# Add here commands to install the package into debian/pimd.
	$(MAKE) install DESTDIR=$(CURDIR)/debian/pimd/ prefix=/usr
	rm -f $(CURDIR)/debian/pimd/usr/share/doc/pimd/INSTALL
	rm -f $(CURDIR)/debian/pimd/usr/share/doc/pimd/LICENSE
	rm -f $(CURDIR)/debian/pimd/usr/share/doc/pimd/LICENSE.mrouted


# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs CHANGES
	dh_installdocs
	dh_installexamples
#	dh_install
#	dh_installmenu
#	dh_installdebconf	
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
	dh_installinit
#	dh_installcron
#	dh_installinfo
	dh_installman pimd.8
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_perl
#	dh_python
#	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

## pimd 2.1.6-1

=== Makefile ===
--- 
+++ 
@@ -17,7 +17,7 @@
 #
 
 # VERSION      ?= $(shell git tag -l | tail -1)
-VERSION      ?= 2.1.2
+VERSION      ?= 2.1.6
 EXEC          = pimd
 CONFIG        = $(EXEC).conf
 PKG           = $(EXEC)-$(VERSION)
@@ -52,7 +52,7 @@
 
 ## Common
 CFLAGS        = $(MCAST_INCLUDE) $(SNMPDEF) $(RSRRDEF) $(INCLUDES) $(DEFS) $(USERCOMPILE)
-CFLAGS       += -O2 -W -Wall -Werror
+CFLAGS       += -O2 -W -Wall -Werror -fno-strict-aliasing
 #CFLAGS       += -O -g
 LDLIBS        = $(SNMPLIBDIR) $(SNMPLIBS) $(EXTRA_LIBS)
 OBJS          = $(IGMP_OBJS) $(ROUTER_OBJS) $(PIM_OBJS) $(DVMRP_OBJS) \
@@ -61,7 +61,7 @@
 DEPS          = $(addprefix .,$(SRCS:.c=.d))
 MANS          = $(addsuffix .8,$(EXEC))
 DISTFILES     = README README.config README.config.jp README.debug \
-		CHANGES INSTALL LICENSE LICENSE.mrouted \
+		ChangeLog INSTALL LICENSE LICENSE.mrouted \
 		TODO CREDITS FAQ AUTHORS
 
 LINT          = splint
@@ -117,7 +117,7 @@
 dist:
 	@echo "Building bzip2 tarball of $(PKG) in parent dir..."
 	git archive --format=tar --prefix=$(PKG)/ $(VERSION) | bzip2 >../$(ARCHIVE)
-	@(cd ..; md5sum $(ARCHIVE))
+	@(cd ..; md5sum $(ARCHIVE) | tee $(ARCHIVE).md5)
 
 build-deb:
 	@echo "Building .deb if $(PKG)..."

=== debian/changelog ===
pimd (2.1.6-1) unstable; urgency=low

  * New upstream version changing location of dump file(s) to
    /var/lib/misc, CVE-2011-0007, Closes: Bug#609304

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Sat, 08 Jan 2011 23:54:41 +0100

pimd (2.1.5-4) unstable; urgency=low

  * Added oknodo to s-s-d in init.d script for stop action
    Closes: Bug#609116

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Sat, 08 Jan 2011 17:56:48 +0100

pimd (2.1.5-3) unstable; urgency=low

  * fix for regression of unused parameter on *bsd, 
    Closes: Bug#608711 (commit 6eaff4dc495ff67933a4)
  * add -Werror to debian/rules

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Mon, 03 Jan 2011 09:22:25 +0100

pimd (2.1.5-2) unstable; urgency=low

  * make package a conflict to smcroute
    https://bugs.launchpad.net/ubuntu/+source/pimd/+bug/362274

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Fri, 10 Dec 2010 13:26:10 +0100

pimd (2.1.5-1) unstable; urgency=low

  * New upstream release.
  * Fix pimd exiting with "setsockopt MRT_DEL_VIF on vif 3: Invalid argument"
    when an interface goes down.  Caused by invalid argument to MRT_DEL_VIF
    on Linux kernels.  *BSD systems not affected.

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Sun, 21 Nov 2010 09:53:57 +0100

pimd (2.1.4-1) unstable; urgency=low

  * New upstream release
  * A serious bcopy()/memcpy() replacement bug in 2.1.3 was fixed.
  * More updates were made for Debian GNU/kFreeBSD.

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Sat, 25 Sep 2010 19:26:34 +0200

pimd (2.1.3-1) unstable; urgency=low

  * New upstream release (Closes: #596117)

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Fri, 10 Sep 2010 13:51:47 +0200

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
 Architecture: any
 Homepage: http://github.com/troglobit/pimd
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Conflicts: mrouted
+Conflicts: mrouted, smcroute
 Description: multicast routing daemon (PIMv2)
  pimd is implementation of Protocol Independent Multicast routing daemon.
  It supports PIMv2-SM on FreeBSD, NetBSD, OpenBSD, Linux. Enabled PIM support

=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,7 @@
 # Uncomment this to turn on verbose mode.
 export DH_VERBOSE=1
 
-CFLAGS = -Wall -g
+CFLAGS = -Wall -Werror -g
 
 ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
 	CFLAGS += -O0
@@ -60,7 +60,7 @@
 binary-arch: build install
 	dh_testdir
 	dh_testroot
-	dh_installchangelogs CHANGES
+	dh_installchangelogs
 	dh_installdocs
 	dh_installexamples
 #	dh_install

## pimd 2.1.6-1ubuntu1

=== Makefile ===
--- 
+++ 
@@ -52,7 +52,7 @@
 
 ## Common
 CFLAGS        = $(MCAST_INCLUDE) $(SNMPDEF) $(RSRRDEF) $(INCLUDES) $(DEFS) $(USERCOMPILE)
-CFLAGS       += -O2 -W -Wall -Werror -fno-strict-aliasing
+CFLAGS       += -O2 -W -Wall -fno-strict-aliasing
 #CFLAGS       += -O -g
 LDLIBS        = $(SNMPLIBDIR) $(SNMPLIBS) $(EXTRA_LIBS)
 OBJS          = $(IGMP_OBJS) $(ROUTER_OBJS) $(PIM_OBJS) $(DVMRP_OBJS) \

=== debian/changelog ===
pimd (2.1.6-1ubuntu1) oneiric; urgency=low

  * Don't build with -Werror. Closes: #634393. LP: #832860.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 14 Sep 2011 09:17:51 +0200

=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,7 @@
 # Uncomment this to turn on verbose mode.
 export DH_VERBOSE=1
 
-CFLAGS = -Wall -Werror -g
+CFLAGS = -Wall -g
 
 ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
 	CFLAGS += -O0

## pimd 2.1.8-1

=== debian/changelog ===
pimd (2.1.8-1) unstable; urgency=low

  * New upstream
  * merges fixes addressing existence of several unused variables and
    handling of CFLAGS, Closes: Bug#634393

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Mon, 24 Oct 2011 08:41:57 +0200

pimd (2.1.7-1) unstable; urgency=low

  * New upstream

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Mon, 05 Sep 2011 11:54:53 +0200

=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,7 @@
 # Uncomment this to turn on verbose mode.
 export DH_VERBOSE=1
 
-CFLAGS = -Wall -g
+CFLAGS = -Wall -Werror -g
 
 ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
 	CFLAGS += -O0
@@ -22,9 +22,11 @@
 	# Add here commands to configure the package.
 	touch configure-stamp
 
-build: build-stamp
+build: build-arch build-indep
+build-arch: build-stamp
+build-indep: build-stamp
 
-build-stamp: configure-stamp 
+build-stamp: configure-stamp
 	dh_testdir
 	# Add here commands to compile the package.
 	$(MAKE)
@@ -50,6 +52,7 @@
 	rm -f $(CURDIR)/debian/pimd/usr/share/doc/pimd/INSTALL
 	rm -f $(CURDIR)/debian/pimd/usr/share/doc/pimd/LICENSE
 	rm -f $(CURDIR)/debian/pimd/usr/share/doc/pimd/LICENSE.mrouted
+	rm -f $(CURDIR)/debian/pimd/usr/share/doc/pimd/ChangeLog*
 
 
 # Build architecture-independent files here.
@@ -60,12 +63,12 @@
 binary-arch: build install
 	dh_testdir
 	dh_testroot
-	dh_installchangelogs
+	dh_installchangelogs ChangeLog
 	dh_installdocs
 	dh_installexamples
 #	dh_install
 #	dh_installmenu
-#	dh_installdebconf	
+#	dh_installdebconf
 #	dh_installlogrotate
 #	dh_installemacsen
 #	dh_installpam

## pimd 2.1.8-2

=== Makefile ===
--- 
+++ 
@@ -17,7 +17,7 @@
 #
 
 # VERSION      ?= $(shell git tag -l | tail -1)
-VERSION      ?= 2.1.6
+VERSION      ?= 2.1.8
 EXEC          = pimd
 CONFIG        = $(EXEC).conf
 PKG           = $(EXEC)-$(VERSION)
@@ -40,7 +40,7 @@
 
 IGMP_OBJS     = igmp.o igmp_proto.o trace.o
 ROUTER_OBJS   = inet.o kern.o main.o config.o debug.o netlink.o routesock.o \
-		vers.o callout.o ${RSRR_OBJS}
+		vers.o callout.o
 PIM_OBJS      = route.o vif.o timer.o mrt.o pim.o pim_proto.o rp.o
 DVMRP_OBJS    = dvmrp_proto.o
 
@@ -51,8 +51,8 @@
 include snmp.mk
 
 ## Common
-CFLAGS        = $(MCAST_INCLUDE) $(SNMPDEF) $(RSRRDEF) $(INCLUDES) $(DEFS) $(USERCOMPILE)
-CFLAGS       += -O2 -W -Wall -fno-strict-aliasing
+CFLAGS       += $(MCAST_INCLUDE) $(SNMPDEF) $(RSRRDEF) $(INCLUDES) $(DEFS) $(USERCOMPILE)
+CFLAGS       += -O2 -W -Wall -Werror -fno-strict-aliasing
 #CFLAGS       += -O -g
 LDLIBS        = $(SNMPLIBDIR) $(SNMPLIBS) $(EXTRA_LIBS)
 OBJS          = $(IGMP_OBJS) $(ROUTER_OBJS) $(PIM_OBJS) $(DVMRP_OBJS) \

=== debian/changelog ===
pimd (2.1.8-2) unstable; urgency=low

  * use dpkg-buildflags for build flags (CFLAGS, LDFLAGS, CPPFLAGS),
    patch from Moritz Muehlenh (Closes: Bug#654081)

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Mon, 02 Jan 2012 08:52:37 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Antonin Kral <A.Kral@sh.cvut.cz>
 Build-Depends: debhelper (>= 7)
-Standards-Version: 3.9.1
+Standards-Version: 3.9.2
 
 Package: pimd
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -5,13 +5,15 @@
 # Uncomment this to turn on verbose mode.
 export DH_VERBOSE=1
 
-CFLAGS = -Wall -Werror -g
+CFLAGS = `dpkg-buildflags --get CFLAGS`
+CFLAGS += -Wall -Werror
+LDFLAGS = `dpkg-buildflags --get LDFLAGS`
+CPPFLAGS = `dpkg-buildflags --get CPPFLAGS`
 
-ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
-	CFLAGS += -O0
-else
-	CFLAGS += -O2
-endif
+export CFLAGS
+export LDFLAGS
+export CPPFLAGS
+
 ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
 	INSTALL_PROGRAM += -s
 endif

## pimd 2.3.1

=== Makefile ===
# -*-Makefile-*-
#
# Note: We use .gz for distribution archives for the sake of
#       OpenBSD not having bzip2 in the base distribution.
#

#VERSION       = $(shell git tag -l | tail -1)
VERSION       = 2.3.1
EXEC          = pimd
CONFIG        = $(EXEC).conf
PKG           = $(EXEC)-$(VERSION)
ARCHTOOL      = `which git-archive-all`
ARCHIVE       = $(PKG).tar
ARCHIVEZ      = ../$(ARCHIVE).gz

ROOTDIR      ?= $(dir $(shell pwd))
RM            = rm -f
CC           := $(CROSS)$(CC)
CHECK        := cppcheck $(CPPFLAGS) --quiet --enable=all

IGMP_OBJS     = igmp.o igmp_proto.o trace.o
ROUTER_OBJS   = inet.o kern.o main.o config.o debug.o vers.o callout.o
PIM_OBJS      = route.o vif.o timer.o mrt.o pim.o pim_proto.o rp.o
DVMRP_OBJS    = dvmrp_proto.o

# This magic trick looks like a comment, but works on BSD PMake
#include <config.mk>
include config.mk

prefix       ?= /usr/local/
sysconfdir   ?= /etc/
datadir       = $(prefix)/share/doc/pimd
mandir        = $(prefix)/share/man/man8

## Common
CPPFLAGS     += -D_PATH_SYSCONF=\"$(sysconfdir)\"
CFLAGS       += $(INCLUDES) $(DEFS) $(USERCOMPILE)
CFLAGS       += -W -Wall -Werror -fno-strict-aliasing
LDLIBS        = $(EXTRA_LIBS)
OBJS          = $(IGMP_OBJS) $(ROUTER_OBJS) $(PIM_OBJS) $(DVMRP_OBJS) $(EXTRA_OBJS)
SRCS          = $(OBJS:.o=.c)
MANS          = $(EXEC).8
DISTFILES     = README.md README-config.md README.config.jp README-debug.md ChangeLog.org \
		CONTRIBUTING.md CODE-OF-CONDUCT.md INSTALL.md LICENSE LICENSE.mrouted     \
		TODO.org CREDITS FAQ.md AUTHORS


all: $(EXEC)

.c.o:
	@printf "  CC      $@\n"
	@$(CC) $(CFLAGS) $(CPPFLAGS) -c -o $@ $<

$(EXEC): $(OBJS)
	@printf "  LINK    $@\n"
	@$(CC) $(CFLAGS) $(LDFLAGS) -Wl,-Map,$@.map -o $@ $(OBJS) $(LDLIBS)

vers.c:
	@echo $(VERSION) | sed -e 's/.*/char todaysversion[]="&";/' > vers.c

install: $(EXEC)
	@install -d $(DESTDIR)$(prefix)/sbin
	@install -d $(DESTDIR)$(sysconfdir)
	@install -d $(DESTDIR)$(datadir)
	@install -d $(DESTDIR)$(mandir)
	@install -m 0755 $(EXEC) $(DESTDIR)$(prefix)/sbin/$(EXEC)
	@install -b -m 0644 $(CONFIG) $(DESTDIR)$(sysconfdir)/$(CONFIG)
	@for file in $(DISTFILES); do \
		install -m 0644 $$file $(DESTDIR)$(datadir)/$$file; \
	done
	@for file in $(MANS); do \
		install -m 0644 $$file $(DESTDIR)$(mandir)/$$file; \
	done

uninstall:
	-@$(RM) $(DESTDIR)$(prefix)/sbin/$(EXEC)
	-@$(RM) $(DESTDIR)$(sysconfdir)/$(CONFIG)
	-@$(RM) -r $(DESTDIR)$(datadir)
	@for file in $(DISTFILES); do \
		$(RM) $(DESTDIR)$(datadir)/$$file; \
	done
	-@for file in $(MANS); do \
		$(RM) $(DESTDIR)$(mandir)/$$file; \
	done

clean:
	-@$(RM) $(OBJS) $(EXEC)

distclean:
	-@$(RM) $(OBJS) core $(EXEC) vers.c config.mk tags TAGS *.o *.map .*.d *.out tags

dist:
	@if [ x"$(ARCHTOOL)" = x"" ]; then \
		echo "Missing git-archive-all from https://github.com/Kentzo/git-archive-all"; \
		exit 1; \
	fi
	@if [ -e $(ARCHIVEZ) ]; then \
		echo "Distribution $(ARCHIVEZ) already exists."; \
		exit 1; \
	fi
	@echo "Building gz tarball of $(PKG) in parent dir ..."
	@$(ARCHTOOL) ../$(ARCHIVE)
	@gzip ../$(ARCHIVE)
	@md5sum $(ARCHIVEZ) | tee $(ARCHIVEZ).md5

build-deb:
	@echo "Building .deb if $(PKG)..."
	git-buildpackage --git-ignore-new --git-upstream-branch=master

check lint:
	$(CHECK) *.c *.h

tags: $(SRCS)
	@ctags $(SRCS)

cflow:
	@cflow $(MCAST_INCLUDE) $(SRCS) > cflow.out

cflow2:
	@cflow -ix $(MCAST_INCLUDE) $(SRCS) > cflow2.out

rcflow:
	@cflow -r $(MCAST_INCLUDE) $(SRCS) > rcflow.out

rcflow2:
	@cflow -r -ix $(MCAST_INCLUDE) $(SRCS) > rcflow2.out

TAGS:
	@etags $(SRCS)

=== libite/Makefile ===
# libite -- Light-weight utility functions and C-library extensions
# 
# Copyright (c) 2008-2015  Joachim Nilsson <troglobit@gmail.com>
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
.PHONY: all install clean

# Figure out root of library, unless used as submodule
ROOTDIR    ?= $(shell pwd)

#VERSION    = $(shell git tag -l | tail -1)
VERSION    ?= 1.0.0
NAME        = libite
PKG         = $(NAME)-$(VERSION)
ARCHIVE     = $(PKG).tar.xz

CC         ?= $(CROSS)gcc
AR         ?= $(CROSS)ar
STRIP      ?= $(CROSS)strip
INSTALL    := install --backup=off
STRIPINST  := $(INSTALL) -s --strip-program=$(CROSS)strip -m 0755

CFLAGS     += -fPIC
CFLAGS     += -Os
CPPFLAGS   += -D_GNU_SOURCE
CPPFLAGS   += -W -Wall
ARFLAGS     = crus

# Default to silent build, use V=1 to get verbose mode.
ifeq ($V,1)
Q           =
PRINT       = @true
MAKEFLAGS   =
else
Q           = @
PRINT       = @printf
MAKEFLAGS   = --no-print-directory --silent
endif

DISTFILES   = README LICENSE
HEADERS     = lite.h
OBJS       := chomp.o copyfile.o dir.o fexist.o fisdir.o fmode.o fsendfile.o
OBJS       += ifconfig.o makepath.o pidfile.o pidfilefn.o rsync.o
OBJS       += strlcpy.o strlcat.o strtonum.o tempfile.o
DEPS       := $(OBJS:.o=.d)
JUNK        = *~ *.bak *.map .*.d *.d DEADJOE semantic.cache *.gdb *.elf core core.*

VER         = 1
LIBNAME     = $(NAME)
SOLIB       = $(LIBNAME).so.$(VER)
SYMLIB      = $(LIBNAME).so
STATICLIB   = $(LIBNAME).a
TARGET      = $(STATICLIB) $(SOLIB)

# Default install paths
prefix     ?= /usr/local
libdir     ?= $(prefix)/lib
datadir    ?= $(prefix)/share/doc/$(LIBNAME)
incdir     ?= $(prefix)/include

# This magic trick looks like a comment, but works on BSD PMake
#include <rules.mk>
include rules.mk

# Build rules
all: $(TARGET)

$(OBJS): Makefile

$(SOLIB): Makefile $(OBJS)
	$(PRINT) "  LINK    %s\n" $@
	$(Q)$(CC) $(LDFLAGS) -shared -Wl,-soname,$@ -o $@ $(OBJS)

$(STATICLIB): Makefile $(OBJS)
	$(Q)$(PRINT) "  ARCHIVE $@\n"
	$(Q)$(AR) $(ARFLAGS) $@ $(OBJS)

install-exec: all
	$(PRINT) "  INSTALL $(DESTDIR)$(libdir)/$(SOLIB)\n"
	$(Q)install -d $(DESTDIR)$(libdir)
	$(Q)$(STRIPINST) $(SOLIB) $(DESTDIR)$(libdir)/$(SOLIB)
	$(Q)ln -sf $(SOLIB) $(DESTDIR)$(libdir)/$(SYMLIB)

install-dev:
	$(Q)install -d $(DESTDIR)$(incdir)/$(LIBNAME)
	$(Q)for file in $(HEADERS); do	                                		\
		printf "  INSTALL $(DESTDIR)$(incdir)/$(LIBNAME)/$$file\n";		\
		$(INSTALL) -m 0644 $$file $(DESTDIR)$(incdir)/$(LIBNAME)/$$file;	\
	done
	$(PRINT) "  INSTALL $(DESTDIR)$(libdir)/$(STATICLIB)\n"
	$(Q)install -d $(DESTDIR)$(libdir)
	$(Q)$(INSTALL) $(STATICLIB) $(DESTDIR)$(libdir)/$(STATICLIB)
	$(Q)install -d $(DESTDIR)$(datadir)
	$(Q)for file in $(DISTFILES); do					\
		printf "  INSTALL $(DESTDIR)$(datadir)/$$file\n";	\
		install -m 0644 $$file $(DESTDIR)$(datadir)/$$file;	\
	done

install: install-exec install-dev

uninstall:
	-$(Q)$(RM) -r $(DESTDIR)$(datadir)
	-$(Q)$(RM) -r $(DESTDIR)$(incdir)/$(LIBNAME)
	-$(Q)$(RM) $(DESTDIR)$(libdir)/$(SOLIB)
	-$(Q)$(RM) $(DESTDIR)$(libdir)/$(SYMLIB)
	-$(Q)$(RM) $(DESTDIR)$(libdir)/$(STATICLIB)

strip: $(TARGET)
	$(Q)$(PRINT) "  STRIP   %s\n" $(TARGET)
	$(Q)$(STRIP) --strip-unneeded $(TARGET)
	$(Q)size $(TARGET)

# Runs Clang scan-build on the whole tree
check: clean
	$(Q)scan-build $(MAKE) all

clean:
	-$(Q)$(RM) $(OBJS) $(DEPS) $(TARGET) $(SOLIB) $(STATICLIB)

distclean:
	-$(Q)$(RM) $(JUNK) unittest *.o *.a *.so* *.unittest

# When called from GNU configure and build system
distdir:
	@git archive --format=tar HEAD | (cd $(distdir); tar xf -)

dist:
	$(Q)echo "Building .xz tarball of $(PKG) in parent dir..."
	git archive --format=tar --prefix=$(PKG)/ v$(VERSION) | xz >../$(ARCHIVE)
	$(Q)(cd ..; md5sum $(ARCHIVE) | tee $(ARCHIVE).md5)

# Include automatically generated rules
-include $(DEPS)

=== debian/changelog ===
pimd (2.3.1-2) unstable; urgency=medium

  * Werror replaced with Wextra in upstream (Closes: Bug#811572)

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Sat, 23 Jan 2016 20:59:08 +0100

pimd (2.3.1-1) unstable; urgency=medium

  * New upstream release

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Sat, 21 Nov 2015 18:09:01 +0100

pimd (2.3.0-1) unstable; urgency=medium

  * New upstream release (closes: #788744, #719555)
    + Mention PIM-SSM support in the package's description
    + Adjust upstream doc names
  * Packaging overhaul
    + Set package format to 3.0 (quilt) (closes: #725554) and filter out
      upstream's debian/.
    + Bump compat to 9
    + Bump standards to 3.9.6, no changes needed
    + Use the dh sequencer
    + d/control: move Homepage to the Source stanza (lintian)
    + drop lintian overrides, no longer valid
  * Drop d/addons/pimd.conf as it uses the old syntax. Ship upstream's config
    instead.
  * Initscript overhaul
    + Source /lib/lsb/init-functions and use the LSB logging functions
    + Wait for pimd to exit on stop/restart
    + Add (graceful) reload and status actions
    + Fill in the descriptions (lintian)
  * Add systemd unit
  * Add d/watch
  * Add a patch fixing spelling errors in the manpage and the pimd binary
    (lintian)
  * Added Apollon as co-maintainer as he is made this awesome update possible

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Tue, 03 Nov 2015 12:19:44 +0100

=== debian/control ===
Source: pimd
Section: net
Priority: optional
Maintainer: Antonin Kral <A.Kral@sh.cvut.cz>
Uploaders: Apollon Oikonomopoulos <apoikos@debian.org>
Build-Depends: debhelper (>= 9), dh-systemd (>= 1.5)
Standards-Version: 3.9.6
Homepage: http://github.com/troglobit/pimd
Vcs-Git: https://github.com/bobek/pkg-pimd.git
Vcs-Browser: https://github.com/bobek/pkg-pimd/tree/debian/sid

Package: pimd
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: mrouted, smcroute
Description: multicast routing daemon (PIMv2)
 pimd is implementation of Protocol Independent Multicast routing daemon.
 It supports PIMv2-SM/SSM on FreeBSD, NetBSD, OpenBSD, Linux. Enabled PIM
 support in kernel is needed.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

%:
	dh $@ --with systemd


override_dh_auto_configure:
	./configure --prefix=/usr --sysconfdir=/etc

override_dh_auto_clean:
	touch config.mk
	dh_auto_clean

override_dh_auto_install:
	dh_auto_install
	rm $(CURDIR)/debian/pimd/usr/share/doc/pimd/LICENSE
	rm $(CURDIR)/debian/pimd/usr/share/doc/pimd/LICENSE.mrouted
	rm $(CURDIR)/debian/pimd/usr/share/doc/pimd/INSTALL.md
	mv $(CURDIR)/debian/pimd/usr/share/doc/pimd/ChangeLog.org \
		$(CURDIR)/debian/pimd/usr/share/doc/pimd/changelog

override_dh_auto_test:

.PHONY: override_dh_auto_clean override_dh_auto_configure \
	override_dh_auto_install override_dh_auto_test

## pimd 2.3.2

=== Makefile ===
--- 
+++ 
@@ -5,7 +5,7 @@
 #
 
 #VERSION       = $(shell git tag -l | tail -1)
-VERSION       = 2.3.1
+VERSION       = 2.3.2
 EXEC          = pimd
 CONFIG        = $(EXEC).conf
 PKG           = $(EXEC)-$(VERSION)
@@ -27,15 +27,15 @@
 #include <config.mk>
 include config.mk
 
-prefix       ?= /usr/local/
-sysconfdir   ?= /etc/
+prefix       ?= /usr/local
+sysconfdir   ?= /etc
 datadir       = $(prefix)/share/doc/pimd
 mandir        = $(prefix)/share/man/man8
 
 ## Common
 CPPFLAGS     += -D_PATH_SYSCONF=\"$(sysconfdir)\"
 CFLAGS       += $(INCLUDES) $(DEFS) $(USERCOMPILE)
-CFLAGS       += -W -Wall -Werror -fno-strict-aliasing
+CFLAGS       += -W -Wall -Wextra -fno-strict-aliasing
 LDLIBS        = $(EXTRA_LIBS)
 OBJS          = $(IGMP_OBJS) $(ROUTER_OBJS) $(PIM_OBJS) $(DVMRP_OBJS) $(EXTRA_OBJS)
 SRCS          = $(OBJS:.o=.c)
@@ -101,7 +101,7 @@
 	@echo "Building gz tarball of $(PKG) in parent dir ..."
 	@$(ARCHTOOL) ../$(ARCHIVE)
 	@gzip ../$(ARCHIVE)
-	@md5sum $(ARCHIVEZ) | tee $(ARCHIVEZ).md5
+	@md5sum $(ARCHIVEZ) | sed 's/..\///' | tee $(ARCHIVEZ).md5
 
 build-deb:
 	@echo "Building .deb if $(PKG)..."

=== debian/changelog ===
pimd (2.3.2-4) unstable; urgency=medium

  * Trim trailing whitespace.
  * Use secure URI in Homepage field.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Update standards version to 4.5.0, no changes needed.
  * Drop `lsb-base`.

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Thu, 20 Jul 2023 16:21:15 +0000

pimd (2.3.2-3) unstable; urgency=medium

  * Fix FTCBFS: Pass CC to make. (Closes: #941678)
    Special thanks to Helmut Grohne
  * Bump compat level to 12 and replace dh-systemd with dh_installsystemd

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Mon, 07 Oct 2019 11:28:22 +0200

pimd (2.3.2-2) unstable; urgency=medium

  * Bump Standards to 3.9.8; no changes needed
  * Enable all hardening flags
  * Depend on lsb-base for the initscript
  * pimd.service: add Documentation key

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Mon, 23 Jan 2017 12:33:14 +0200

pimd (2.3.2-1) unstable; urgency=medium

  * New upstream release

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Mon, 14 Mar 2016 11:17:00 +0100

=== debian/control ===
--- 
+++ 
@@ -3,14 +3,15 @@
 Priority: optional
 Maintainer: Antonin Kral <A.Kral@sh.cvut.cz>
 Uploaders: Apollon Oikonomopoulos <apoikos@debian.org>
-Build-Depends: debhelper (>= 9), dh-systemd (>= 1.5)
-Standards-Version: 3.9.6
-Homepage: http://github.com/troglobit/pimd
+Build-Depends: debhelper-compat (= 12)
+Standards-Version: 4.5.0
+Homepage: https://github.com/troglobit/pimd
 Vcs-Git: https://github.com/bobek/pkg-pimd.git
 Vcs-Browser: https://github.com/bobek/pkg-pimd/tree/debian/sid
 
 Package: pimd
 Architecture: any
+Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Conflicts: mrouted, smcroute
 Description: multicast routing daemon (PIMv2)

=== debian/rules ===
--- 
+++ 
@@ -1,14 +1,18 @@
 #!/usr/bin/make -f
 
-# Uncomment this to turn on verbose mode.
 export DH_VERBOSE=1
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+
+include /usr/share/dpkg/buildtools.mk
 
 %:
-	dh $@ --with systemd
-
+	dh $@
 
 override_dh_auto_configure:
 	./configure --prefix=/usr --sysconfdir=/etc
+
+override_dh_auto_build:
+	dh_auto_build -- 'CC=$(CC)'
 
 override_dh_auto_clean:
 	touch config.mk
@@ -16,6 +20,7 @@
 
 override_dh_auto_install:
 	dh_auto_install
+	dh_installsystemd
 	rm $(CURDIR)/debian/pimd/usr/share/doc/pimd/LICENSE
 	rm $(CURDIR)/debian/pimd/usr/share/doc/pimd/LICENSE.mrouted
 	rm $(CURDIR)/debian/pimd/usr/share/doc/pimd/INSTALL.md
